import { createParamDecorator, ExecutionContext } from '@nestjs/common'
import { type Request } from 'express'
import { UserEntity } from 'src/users/entities/user.entity'

export const User = createParamDecorator(
  (key: string, ctx: ExecutionContext) => {
    const request = ctx.switchToHttp().getRequest<Request>()
    const user = request.user as UserEntity

    return key ? user?.[key] : user
  },
)
